//#define DEBUG    // Herauskommentieren, wenn keine serielle Ausgabe erwünscht

#ifdef DEBUG
  #define debug_print(x)  Serial.print(x)
  #define debug_println(x)  Serial.println(x)
#else
  #define debug_print(x)
  #define debug_println(x)
#endif

#include "FS.h"
#include "SD.h"
#include "SPI.h"
#include <TFT_eSPI.h>              // Hardware-specific library
#include <PNGdec.h>
TFT_eSPI tft = TFT_eSPI();         // Invoke custom library
PNG png; // PNG decoder instance
int maxfile, zaehler, filecount, z, sdtest;
int16_t xpos = 0;
int16_t ypos = 0;
unsigned long dateilaenge;
unsigned long f;
uint8_t dateiinhalt[190000];      // RAM-Puffer für Bild
const char* dateiname;
const char* datei[200];
char* newString;
#define MAX_IMAGE_WIDTH 280 // Für 280 x 240 TFT



void pngDraw(PNGDRAW *pDraw) {    // PNG auf TFT ausgeben
  uint16_t lineBuffer[MAX_IMAGE_WIDTH];
  png.getLineAsRGB565(pDraw, lineBuffer, PNG_RGB565_BIG_ENDIAN, 0xffffffff);
  tft.pushImage(xpos, ypos + pDraw->y, pDraw->iWidth, 1, lineBuffer);
}
void bildausgabe() {            // PNG in Bitmap wandeln
   debug_println("Los gehts...");
   int16_t rc = png.openFLASH((uint8_t *)dateiinhalt, dateilaenge, pngDraw);
   if (rc == PNG_SUCCESS) {
    debug_println("Successfully opened png file");
    #ifdef DEBUG
    Serial.printf("image specs: (%d x %d), %d bpp, pixel type: %d\n", png.getWidth(), png.getHeight(), png.getBpp(), png.getPixelType());
    #endif
    tft.startWrite();
    uint32_t dt = millis();
    rc = png.decode(NULL, 0);
    debug_print(millis() - dt); debug_println("ms");
    tft.endWrite();
    //png.close(); // not needed for memory->memory decode
  }
}
void datei_puffer() {
  File myFile;
             // Bild von SD in RAM laden
 myFile = SD.open(datei[z]);
 if (myFile) {
    debug_println("Ausgabe:");

 dateilaenge = myFile.size();
 debug_print("Dateilänge: ");
 debug_println(dateilaenge);
 f = 0;
 //delay(2000);
 while (myFile.available()) {   
   dateiinhalt[f]=(myFile.read());
   f++;
 } 
    // close the file:
    myFile.close();
  } else {
    // if the file didn't open, print an error:
    debug_print("error opening ");
    debug_println(dateiname);
  }
}
//------
void dir_einlesen() {
  
  filecount = 0;
  File dir = SD.open("/");
  while (true) {
    File entry = dir.openNextFile();
    if (!entry) break;
    if (entry.isDirectory() == false) {
      const char *name = entry.name();
      const int len = strlen(name);
      if (len > 3 && strcmp(name + len - 3, "png") == 0) {
       newString = new char[strlen(name) + 2];
       newString[0] = '/';
       strcpy(newString + 1, name);
       dateiname = newString;
       debug_println(dateiname);
       datei[filecount] = dateiname;
       filecount = filecount + 1;
      }
    }
    entry.close();
  }
  if (filecount == 0) {
       delay(2000);
  }


 
}
//------

void setup() {
#ifdef DEBUG  
  Serial.begin(115200);
  while(!Serial){} // needed for some Boards
  delay(1000); // helps in case of incomplete output on serial monitor
#endif 
digitalWrite(7,HIGH);
digitalWrite(3,HIGH);
//pinMode(6, OUTPUT);
sdtest=1;
delay(1000); 
if (!SD.begin()) {
    Serial.println("Card Mount Failed");
    sdtest=0;
    //return;
  }
debug_println(sdtest);
tft.begin();
tft.fillScreen(TFT_BLACK);
//tft.initDMA();
tft.setRotation(1); // Querformat
tft.fillScreen(TFT_BLUE);
tft.setTextColor(TFT_WHITE,TFT_BLUE);
tft.setCursor(50, 60, 4);
tft.println("ESP32C3 Diashow");
tft.setCursor(80, 90, 4);
tft.println("Version 5");
delay(2000);
//SPI.begin(sck, miso, mosi, cs);
 
  if (!sdtest) {
  
    debug_println("2 Card Mount Failed");
    tft.fillScreen(TFT_RED);
    tft.setTextColor(TFT_WHITE,TFT_RED);
    tft.setCursor(100, 60, 4);
    tft.println("Fehler!");
    tft.setCursor(50, 90, 4);
    tft.println("Keine SD-Karte ?");
    return;
  }
 uint8_t cardType = SD.cardType();
  
  

  if (cardType == CARD_NONE) {
    debug_println("SD-Kartenproblem");
    tft.fillScreen(TFT_RED);
    tft.setTextColor(TFT_WHITE,TFT_RED);
    tft.setCursor(100, 60, 4);
    tft.println("Fehler!");
    tft.setCursor(50, 90, 4);
    tft.println("Unbekannte SD");
    return;
  }

  debug_print("SD Card Type: ");
  if (cardType == CARD_MMC) {
    debug_println("MMC");
    tft.fillScreen(TFT_GREEN);
    tft.setTextColor(TFT_BLACK,TFT_GREEN);
    tft.setCursor(0, 60, 4);
    tft.println("MMC-Karte gefunden.");
  } else if (cardType == CARD_SD) {
    debug_println("SDSC");
    tft.fillScreen(TFT_GREEN);
    tft.setTextColor(TFT_BLACK,TFT_GREEN);
    tft.setCursor(25, 60, 4);
    tft.println("SD-Karte gefunden.");
  } else if (cardType == CARD_SDHC) {
    debug_println("SDHC");
    tft.fillScreen(TFT_GREEN);
    tft.setTextColor(TFT_BLACK,TFT_GREEN);
    tft.setCursor(15, 60, 4);
    tft.println("SDSC-Karte gefunden.");
  } else {
    debug_println("UNKNOWN");
  }

uint64_t cardSize = SD.cardSize() / (1024 * 1024);
#ifdef DEBUG
  Serial.printf("SD Card Size: %lluMB\n", cardSize);
#endif
  tft.setCursor(25, 90, 4);
  tft.print("Speicher: ");
  tft.print(cardSize);
  tft.println(" MB");
  dir_einlesen();
  debug_println("Verzeichnis eingelesen");
  debug_println(filecount);
  tft.setCursor(25, 120, 4);
  tft.print(filecount);
  tft.println(" Bilder.");

delay(2000);  
//----------------
}

void loop() {
  z = 0;
  delay(2000);
  while (z < filecount) {
    debug_println(datei[z]);
    datei_puffer();
    bildausgabe();
    delay(5000);
    z++;
  }

 debug_println("fertig");
}
